## grafx2-2.8-1.src.tar.gz

=== java/Makefile ===
VERSION = 5.1.1
SEVENZIP = 7z a -mx=9 -bd -bso0

RESOURCES := ../atari8.fnt ../altirrapal.pal ../c16.pal ../c64.fnt ../zx81.fnt

all: recoil-$(VERSION)-java.jar recoil-$(VERSION)-javadoc.zip

recoil-$(VERSION)-java.jar: net/sf/recoil/RECOIL.class net/sf/recoil/atari8.fnt
	jar cf $@ net

net/sf/recoil/RECOIL.class: java/RECOIL.java
	mkdir -p $(@D) && javac -d . java/*.java

net/sf/recoil/atari8.fnt: $(RESOURCES)
	mkdir -p $(@D) && cp $^ $(@D)

java/RECOIL.java: ../recoil.ci $(RESOURCES)
	mkdir -p $(@D) && cito -o $@ -n net.sf.recoil -I .. $<

recoil-$(VERSION)-javadoc.zip: recoil-$(VERSION)-javadoc/index.html
	$(SEVENZIP) -tzip $@ $(<D)

recoil-$(VERSION)-javadoc/index.html: java/RECOIL.java
	javadoc -d $(@D) java/*.java

clean:
	$(RM) recoil-$(VERSION)-java.jar recoil-$(VERSION)-javadoc.zip
	rm -rf net java recoil-$(VERSION)-javadoc

.PHONY: clean

=== osx/Makefile ===
VERSION = 5.1.1

CC = gcc
# As of Xcode 4.6.3, -O2 allocates a 2.5MB of stack for RECOIL_Decode, which causes non-deterministic bus errors :(
CFLAGS = -O1 -Wall -mmacosx-version-min=10.6
QLRECOIL = bin/RECOIL.qlgenerator/Contents/MacOS/qlrecoil 
PLIST = bin/RECOIL.qlgenerator/Contents/Info.plist
QLCODESIGN = bin/RECOIL.qlgenerator/Contents/_CodeSignature/CodeResources

recoil-$(VERSION)-macos.dmg: bin/QuickLook $(QLCODESIGN) $(QLRECOIL) $(PLIST) bin/XnViewMP bin/Xrecoil.usr bin/bin bin/recoil2png
	hdiutil create -volname recoil-$(VERSION)-macos -srcfolder bin -format UDBZ -fs HFS+ -imagekey bzip2-level=3 -ov $@

bin/QuickLook:
	mkdir -p $(@D) && ln -s /Library/QuickLook $@

$(QLCODESIGN): $(QLRECOIL) $(PLIST)
ifdef RECOIL_CODESIGNING_IDENTITY
	codesign --entitlements entitlements.xml -f -s "$(RECOIL_CODESIGNING_IDENTITY)" bin/RECOIL.qlgenerator
else
	rm -rf $(@D)
endif

$(QLRECOIL): qlrecoil.c ../recoil-stdio.c ../recoil-stdio.h ../recoil.c ../recoil.h
	mkdir -p $(@D) && $(CC) $(CFLAGS) -o $@ -I .. -dynamiclib qlrecoil.c ../recoil-stdio.c ../recoil.c -framework QuickLook -framework ApplicationServices -framework CoreFoundation && strip -x $@

$(PLIST): Info.plist.xsl ../formats.xml
	mkdir -p $(@D) && xsltproc -o $@ Info.plist.xsl ../formats.xml

bin/XnViewMP:
	mkdir -p $(@D) && ln -s /Applications/XnViewMP.app/Contents/MacOS/Plugins $@

bin/Xrecoil.usr: ../Xrecoil.c ../formats.h ../recoil-stdio.c ../recoil-stdio.h ../recoil.c ../recoil.h
	mkdir -p $(@D) && $(CC) $(CFLAGS) -o $@ -I .. -dynamiclib ../Xrecoil.c ../recoil-stdio.c ../recoil.c

../formats.h: ../formats.h.xsl ../formats.xml
	xsltproc -o $@ ../formats.h.xsl ../formats.xml

bin/bin:
	mkdir -p $(@D) && ln -s /usr/local/bin $@

bin/recoil2png: ../recoil2png.c ../pngsave.c ../pngsave.h ../recoil-stdio.c ../recoil-stdio.h ../recoil.c ../recoil.h
	mkdir -p $(@D) && $(CC) $(CFLAGS) -o $@ -I .. ../recoil2png.c ../pngsave.c ../recoil-stdio.c ../recoil.c /usr/local/lib/libpng.a -lz

%.c %.h: %.ci ../atari8.fnt ../altirrapal.pal ../c16.pal ../c64.fnt ../zx81.fnt
	cito -o $*.c -I .. $<

clean:
	rm -rf recoil-$(VERSION)-macos.dmg bin  ../formats.h

.PHONY: clean

.DELETE_ON_ERROR:

=== win32/Makefile ===
VERSION = 5.1.1

CITO = cito
XSLTPROC = xsltproc -o $@ $^
CFLAGS = -Wall -O2 -s
CSOURCES = $(patsubst %/,-I%,$(sort $(dir $(filter %.h,$^)))) $(^:%.h=)
LDFLAGS_DLL = -shared -Wl,--kill-at -Wl,-subsystem,windows
CC = $(@D)-w64-mingw32-gcc -o $@ $(CFLAGS) $(CSOURCES)
CXX = $(@D)-w64-mingw32-g++ -o $@ $(CFLAGS)
WINDRES = $(@D)-w64-mingw32-windres -o $@
CSC = C:/Windows/Microsoft.NET/Framework/v4.0.30319/csc.exe -nologo -o+ -out:$@
RM = rm -f
UNIX2DOS = unix2dos <$< >$@
GIT = git
TAR = /usr/bin/tar
SEVENZIP = 7z a -mx=9 -bd -bso0
CANDLE = candle -ext WixUtilExtension -nologo -o $@
LIGHT = light -ext WixUtilExtension -nologo -o $@ -spdb
MAGICK = magick
IMAGEMAGICK_i686_DIR = C:\Program Files (x86)\ImageMagick-6.9.11-Q16-HDRI
IMAGEMAGICK_x86_64_DIR = C:\Program Files\ImageMagick-6.9.11-Q16-HDRI
PAINT_NET_DIR = C:\Program Files\paint.net
ifdef V
DO = mkdir -p $(@D) && 
else
DO = @echo $@ && mkdir -p $(@D) && 
endif

WIN32_BIN = i686/recoil2png.exe i686/IM_MOD_RL_recoil_.dll i686/Xrecoil.usr i686/recoilwin.exe i686/thumbrecoil.dll i686/RECOIL.plg paint.net/RecoilPaintDotNet.dll
WIN64_BIN = $(WIN32_BIN) x86_64/IM_MOD_RL_recoil_.dll x86_64/Xrecoil.usr x86_64/thumbrecoil.dll x86_64/RECOIL.plg64

all: $(WIN32_BIN)

i686/recoil2png.exe: ../recoil2png.c ../pngsave.c ../pngsave.h ../recoil-stdio.c ../recoil-stdio.h ../recoil.c ../recoil.h
	$(DO)$(CC) -static -lpng16 -lz

i686/IM_MOD_RL_recoil_.dll x86_64/IM_MOD_RL_recoil_.dll: ../imagemagick/recoilmagick.c ../formats.h ../recoil.c ../recoil.h
	$(DO)$(CC) $(LDFLAGS_DLL) -I"$(IMAGEMAGICK_$(@D)_DIR)"/include -lCORE_RL_magick_ -L"$(IMAGEMAGICK_$(@D)_DIR)" -static-libgcc
 
i686/Xrecoil.usr x86_64/Xrecoil.usr: ../Xrecoil.c ../formats.h ../recoil-stdio.c ../recoil-stdio.h ../recoil.c ../recoil.h
	$(DO)$(CC) $(LDFLAGS_DLL) -static 

%/recoilwin.exe: recoilwin/recoilwin.c recoilwin/recoilwin.h recoil-win32.c recoil-win32.h %/recoilwin-res.o ../pngsave.c ../pngsave.h ../formats.h ../recoil.c ../recoil.h
	$(DO)$(CC) -Wl,-subsystem,windows -lcomctl32 -lcomdlg32 -lgdi32 -static -lpng16 -lz

i686/recoilwin-res.o x86_64/recoilwin-res.o: recoilwin/recoilwin.rc recoilwin/recoilwin.h recoil.ico ../recoil.h
	$(DO)$(WINDRES) -I.. $<

i686/thumbrecoil.dll x86_64/thumbrecoil.dll: thumbrecoil/thumbrecoil.cpp ../formats.h recoil-win32.c recoil-win32.h ../recoil.c ../recoil.h
	$(DO)$(CXX) $(LDFLAGS_DLL) -I. -I.. thumbrecoil/thumbrecoil.cpp -xc recoil-win32.c -xc ../recoil.c -static -lgdi32 -lole32 -luuid

i686/RECOIL.plg x86_64/RECOIL.plg64: imagine/recoilimagine.c ../formats.h ../recoil.c ../recoil.h
	$(DO)$(CC) $(LDFLAGS_DLL) -static

paint.net/RecoilPaintDotNet.dll: paint.net/RecoilPaintDotNet.cs paint.net/RecoilFileTypeFactory.cs paint.net/RECOIL.cs
	$(DO)$(CSC) -t:library $(subst /,\\,$^) -r:"$(PAINT_NET_DIR)\PaintDotNet.Base.dll" -r:"$(PAINT_NET_DIR)\PaintDotNet.Core.dll" -r:"$(PAINT_NET_DIR)\PaintDotNet.Data.dll"

paint.net/RecoilFileTypeFactory.cs: paint.net/RecoilFileTypeFactory.cs.xsl ../formats.xml
	$(DO)$(XSLTPROC)

paint.net/RECOIL.cs: ../recoil.ci ../atari8.fnt ../altirrapal.pal ../c16.pal ../c64.fnt ../zx81.fnt
	$(DO)$(CITO) -o $@ -I .. -n Recoil $<

i686/by-platform.exe: by-platform.c recoil-win32.c recoil-win32.h ../recoil.c ../recoil.h
	$(DO)$(CC) -static

../formats.h: ../formats.h.xsl ../formats.xml
	$(DO)$(XSLTPROC)

# http://www.cmcrossroads.com/article/rules-multiple-outputs-gnu-make
%.c %.h: %.ci ../atari8.fnt ../altirrapal.pal ../c16.pal ../c64.fnt ../zx81.fnt
	$(DO)$(CITO) -o $*.c -I .. $<

recoil.ico: ../recoil-512x512.png
	$(DO)$(MAGICK) $< -resize 48x48 $@

COPYING.txt: ../COPYING
	$(DO)$(UNIX2DOS)

setup: ../../recoil-$(VERSION)-win32.msi

x64-setup: ../../recoil-$(VERSION)-win64.msi

../../recoil-$(VERSION)-win32.msi: i686/recoil.wixobj recoil.ico setup/dialog.jpg setup/banner.jpg setup/license.rtf $(WIN32_BIN)
	$(DO)$(LIGHT) -ext WixUIExtension -sice:ICE69 $<

../../recoil-$(VERSION)-win64.msi: x86_64/recoil.wixobj recoil.ico setup/dialog.jpg setup/banner.jpg setup/license.rtf $(WIN64_BIN)
	$(DO)$(LIGHT) -ext WixUIExtension -sice:ICE69 -sice:ICE80 $<

i686/recoil.wixobj x86_64/recoil.wixobj: setup/recoil.wxs setup/formats.wxi
	$(DO)$(CANDLE) $(and $(@D:i686=), -arch x64) $<

setup/formats.wxi: setup/formats.wxi.xsl ../formats.xml
	$(DO)$(XSLTPROC)

setup/dialog.jpg: ../recoil-512x512.png
	$(DO)$(MAGICK) $< -resize 148 -extent 493x312-16-82 -strip $@

setup/banner.jpg: ../recoil-512x512.png
	$(DO)$(MAGICK) $< -resize 48 -extent 493x58-425-5 -strip $@

../MANIFEST:
	$(DO)test -e ../.git && ( \
		($(GIT) --git-dir=../.git ls-files | grep -vF .gitignore \
			&& echo MANIFEST && echo recoil.c && echo recoil.h) | sort | dos2unix >$@; \
	)

srcdist: ../../recoil-$(VERSION).tar.gz

../../recoil-$(VERSION).tar.gz: ../MANIFEST ../recoil.c ../recoil.h
	$(DO)$(RM) $@ && $(TAR) -c --numeric-owner --owner=0 --group=0 --mode=644 -C .. -T ../MANIFEST --transform=s,,recoil-$(VERSION)/, | $(SEVENZIP) -tgzip -si $@

dist: srcdist ../../recoil-$(VERSION)-win32.zip setup x64-setup

../../recoil-$(VERSION)-win32.zip: COPYING.txt $(WIN32_BIN)
	$(DO)$(RM) $@ && $(SEVENZIP) -tzip $@ COPYING.txt $(WIN32_BIN:%=./%)

deb64:
	scp ../../recoil-$(VERSION).tar.gz vm:.
	ssh vm 'rm -rf recoil-$(VERSION) && tar xf recoil-$(VERSION).tar.gz && make -C recoil-$(VERSION) deb'
	scp vm:recoil-2png_$(VERSION)-1_amd64.deb vm:recoil-xnview_$(VERSION)-1_amd64.deb vm:recoil-thumbnailer_$(VERSION)-1_all.deb ../../

rpm64:
	scp ../../recoil-$(VERSION).tar.gz vm:.
	ssh vm 'rpmbuild -tb recoil-$(VERSION).tar.gz'
	scp vm:rpmbuild/RPMS/x86_64/recoil-2png-$(VERSION)-1.x86_64.rpm vm:rpmbuild/RPMS/noarch/recoil-thumbnailer-$(VERSION)-1.noarch.rpm ../../

clean:
	$(RM) $(WIN64_BIN) i686/recoilwin-res.o recoil.ico COPYING.txt \
		i686/recoil.wixobj x86_64/recoil.wixobj setup/formats.wxi setup/dialog.jpg setup/banner.jpg \
		paint.net/RecoilFileTypeFactory.cs paint.net/RECOIL.cs ../formats.h

.PHONY: all clean setup x64-setup ../MANIFEST srcdist dist deb64 rpm64 ../../recoil-$(VERSION).tar.gz

.DELETE_ON_ERROR:

=== www/Makefile ===
TARGETS = index.html formats.html android.html windows.html macos.html linux.html web.html news.html contact.html privacy.html recoil.js recoil-180x180.png

all: $(TARGETS)

%.html: %.xml www.xsl ../formats.xml
	xsltproc -o $@ www.xsl $< && java -jar C:/bin/vnu.jar $@

recoil.js: ../recoil.ci ../atari8.fnt ../altirrapal.pal ../c16.pal ../c64.fnt ../zx81.fnt
	cito -o $@ -I .. $<

recoil-180x180.png: ../recoil-512x512.png
	magick $< -resize 180x180 -quality 95 -strip $@

clean:
	$(RM) $(TARGETS)

.PHONY: all clean

.DELETE_ON_ERROR:

=== debian/changelog ===
recoil (5.1.1-1) UNRELEASED; urgency=low

  * New release.

 -- Piotr Fusik <fox@scene.pl>  Fri, 30 Oct 2020 10:37:43 +0100

recoil (5.1.0-1) UNRELEASED; urgency=low

  * New release.

 -- Piotr Fusik <fox@scene.pl>  Tue, 8 Sep 2020 14:15:21 +0200

recoil (5.0.1-1) UNRELEASED; urgency=low

  * New release.

 -- Piotr Fusik <fox@scene.pl>  Wed, 18 Mar 2020 17:37:54 +0100

recoil (5.0.0-1) UNRELEASED; urgency=low

  * New release.

 -- Piotr Fusik <fox@scene.pl>  Tue, 12 Nov 2019 09:35:17 +0100

recoil (4.3.2-1) UNRELEASED; urgency=low

  * New release.

 -- Piotr Fusik <fox@scene.pl>  Sat, 6 Jul 2019 09:58:32 +0200

recoil (4.3.1-1) UNRELEASED; urgency=low

  * New release.

 -- Piotr Fusik <fox@scene.pl>  Wed, 5 Dec 2018 21:08:30 +0100

recoil (4.3.0-1) UNRELEASED; urgency=low

  * New release.

 -- Piotr Fusik <fox@scene.pl>  Sun, 10 Jun 2018 11:17:46 +0200

recoil (4.2.0-1) UNRELEASED; urgency=low

  * New release.

 -- Piotr Fusik <fox@scene.pl>  Tue, 20 Feb 2018 16:06:42 +0100

recoil (4.1.0-1) UNRELEASED; urgency=low

  * New release.

 -- Piotr Fusik <fox@scene.pl>  Wed, 18 Oct 2017 18:45:04 +0100

recoil (4.0.0-1) UNRELEASED; urgency=low

  * New release.

 -- Piotr Fusik <fox@scene.pl>  Wed, 17 May 2017 13:21:57 +0200

recoil (3.5.0-1) UNRELEASED; urgency=low

  * New release.

 -- Piotr Fusik <fox@scene.pl>  Thu, 1 Dec 2016 18:15:54 +0100

recoil (3.4.0-1) UNRELEASED; urgency=low

  * New release.

 -- Piotr Fusik <fox@scene.pl>  Tue, 2 Feb 2016 09:27:52 +0100

recoil (3.3.0-1) UNRELEASED; urgency=low

  * New release.

 -- Piotr Fusik <fox@scene.pl>  Fri, 7 Aug 2015 17:56:32 +0200

recoil (3.2.0-1) UNRELEASED; urgency=low

  * New release.

 -- Piotr Fusik <fox@scene.pl>  Wed, 28 Jan 2015 10:42:15 +0100

recoil (3.1.0-1) UNRELEASED; urgency=low

  * First deb packaging.

 -- Piotr Fusik <fox@scene.pl>  Wed, 25 Jun 2014 09:58:19 +0200

=== PKGBUILD ===
# Maintainer: Alexander F. Rødseth <xyproto@archlinux.org>
# Contributor: Simon Parzer <simon.parzer@gmail.com>

pkgname=grafx2
pkgver=2.8
pkgrel=1
_recoilver=5.1.1
pkgdesc='Pixelart-oriented painting program'
arch=(x86_64)
url='http://grafx2.chez.com/'
license=(GPL2)
depends=(fontconfig hicolor-icon-theme lua sdl2_image sdl2_ttf)
makedepends=(git)
options=(!emptydirs)
source=("https://sourceforge.net/projects/recoil/files/recoil/$_recoilver/recoil-$_recoilver.tar.gz"
        "git+https://gitlab.com/GrafX2/grafX2.git#commit=3fa8c98c17b01246c3d39acbeedf4b3db4de6654") # tag: v2.8
b2sums=('0748c0c6f795919af377b3718af482fe4c86b65b0370403d08bb60ad86b8ca78d43fe512410214e3ca8ed2bf46f68ee12c320efc26c3f256024c31c3e3dac205'
        SKIP)

prepare() {
  mv grafX2 $pkgname
  sed -i 's/-liconv//g' $pkgname/src/Makefile

  # update the website URL
  sed -i 's,2\.tk,2.chez.com,' $pkgname/misc/unix/grafx2.appdata.xml

  # TODO: package recoil (retro computer image library) as a separate package
  mkdir -p grafx2/3rdparty/archives
  cp -u recoil-$_recoilver.tar.gz grafx2/3rdparty/archives/recoil-$_recoilver.tar.gz
}

build() {
  make -C $pkgname/src API=sdl2 PREFIX=/usr
}

package() {
  install -d "$pkgdir/usr/share/grafx2/scripts/samples_2.4/picture/"{thomson/lib,others-8bit/lib}
  make -C $pkgname/src API=sdl2 DESTDIR="$pkgdir" PREFIX=/usr install
  mv "$pkgdir/usr/bin/grafx2"{-sdl2,}
  install -Dm644 $pkgname/doc/README.txt "$pkgdir/usr/share/doc/$pkgname/README"
}

=== debian/control ===
Source: recoil
Maintainer: Piotr Fusik <fox@scene.pl>
Section: graphics
Priority: optional
Standards-Version: 3.9.3
Build-Depends: debhelper (>= 7), gcc, libpng-dev, xsltproc

Package: recoil-2png
Architecture: any
Depends: ${shlibs:Depends}
Description: Provides "recoil2png" command-line converter
 of pictures in native formats of
 Amiga, Amstrad CPC, Apple II, Atari 8-bit/Portfolio/ST/TT/Falcon,
 BBC Micro, Commodore VIC-20/16/64/128, Electronika BK, FM Towns,
 Macintosh 128K, MSX, NEC PC-80/88/98, Oric, Psion Series 3, SAM Coupe,
 Sharp X68000, Timex 2048, TRS-80, TRS-80 Color Computer, ZX81
 and ZX Spectrum computers.

Package: recoil-thumbnailer
Architecture: all
Depends: recoil-2png
Description: GNOME thumbnailer for pictures in native formats of
 Amiga, Amstrad CPC, Apple II, Atari 8-bit/Portfolio/ST/TT/Falcon,
 BBC Micro, Commodore VIC-20/16/64/128, Electronika BK, FM Towns,
 Macintosh 128K, MSX, NEC PC-80/88/98, Oric, Psion Series 3, SAM Coupe,
 Sharp X68000, Timex 2048, TRS-80, TRS-80 Color Computer, ZX81
 and ZX Spectrum computers.

Package: recoil-xnview
Architecture: any
Depends: ${shlibs:Depends}
Description: Plugin for XnView MP to decode pictures in native formats of
 Amiga, Amstrad CPC, Apple II, Atari 8-bit/Portfolio/ST/TT/Falcon,
 BBC Micro, Commodore VIC-20/16/64/128, Electronika BK, FM Towns,
 Macintosh 128K, MSX, NEC PC-80/88/98, Oric, Psion Series 3, SAM Coupe,
 Sharp X68000, Timex 2048, TRS-80, TRS-80 Color Computer, ZX81
 and ZX Spectrum computers.
